package {
	
	import com.flowingdata.gps.MarkersClip;
	import com.modestmaps.Map;
	import com.modestmaps.TweenMap;
	import com.modestmaps.core.MapExtent;
	import com.modestmaps.geo.Location;
	import com.modestmaps.mapproviders.microsoft.*;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.ColorTransform;
	import flash.net.*;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import mx.effects.easing.*;
	
	[SWF(width="900", height="400", backgroundColor="#ffffff", frameRate="32")]
	public class Walmarts extends Sprite
	{	
		private var map:Map;
		private var mapWidth:Number = stage.stageWidth;
		private var mapHeight:Number = stage.stageHeight;
		private var markers:MarkersClip;
		private var navButtons:Sprite;
		
		private var urlLoader:URLLoader;
		private var locations:Array = new Array();
		private var openingDates:Array = new Array();
		
		private var yearLabel:TextField;
		private var storeCount:TextField;
		private var textFormat:TextFormat;
		
		
		public function Walmarts()
		{	
			stage.scaleMode = StageScaleMode.NO_SCALE;
	        stage.align = StageAlign.TOP_LEFT;
			
			// Initialize map			
			map = new TweenMap(mapWidth, mapHeight, true, new MicrosoftRoadMapProvider());
			map.setExtent(new MapExtent(50.259381, 24.324408, -128.320313, -59.941406));
			
			// Grayscale
			var mat:Array = [0.24688,0.48752,0.0656,0,44.7,0.24688,0.48752,0.0656,0,44.7,0.24688,0.48752,0.0656,0,44.7,0,0,0,1,0];
	        var colorMat:ColorMatrixFilter = new ColorMatrixFilter(mat);
	        map.grid.filters = [colorMat];
	        
			
	        addChild(map);
	        map.x = 0; map.y = 0;
			
			
			yearLabel = new TextField();
			textFormat = new TextFormat('Arial', 30, 0xFFFFFF, true);
			addChild(yearLabel);
			yearLabel.x = 800; yearLabel.y = 350;
			
			storeCount = new TextField();
			storeCount.text = '0';
			addChild(storeCount);
			storeCount.x = 10; storeCount.y = 10;
			storeCount.scaleX = 0.5; storeCount.scaleY = 0.5;
			
			// Navigation buttons (zooming)
			var buttons:Array = new Array();
	        navButtons = new Sprite();
	        addChild(navButtons);
	        buttons.push(makeButton(navButtons, 'plus', '+', map.zoomIn));
	        buttons.push(makeButton(navButtons, 'minus', '–', map.zoomOut));
	        var nextX:Number = 0;
			for(var i:Number = 0; i < buttons.length; i++) {
				var currButton:Sprite = buttons[i];
				Sprite(buttons[i]).scaleX = 3;
				Sprite(buttons[i]).scaleY = 3;
				Sprite(buttons[i]).x = nextX;
				nextX += 3*Sprite(buttons[i]).getChildByName('label').width;
			}
			navButtons.x = 0; navButtons.y = map.height-navButtons.height;
			
			
			// Load library data
			var urlRequest:URLRequest = new URLRequest('walmarts.xml');
			urlLoader = new URLLoader();
			urlLoader.addEventListener(Event.COMPLETE, onLoadLibraries);
			urlLoader.load(urlRequest);
			
			
		}
		
		
		private function onLoadLibraries(e:Event):void
		{
			var xml:XML = new XML(e.target.data);
			
			for each(var w:* in xml.walmart) 
	    	{	
	    		locations.push(new Location(w.latitude, w.longitude));
	    		openingDates.push(String(w.opening_date));
	    	}
	    	
	    	var brightGreen:uint = 0x7CFC00;
	    	markers = new MarkersClip(map, locations, openingDates, brightGreen);
	    	map.addChild(markers);
	    	
	    	addEventListener(Event.ENTER_FRAME, onEnterFrame);			
		}
		
		
		
		public function makeButton(clip:Sprite, name:String, labelText:String, action:Function):Sprite
	    {
	        var button:Sprite = new Sprite();
	        button.name = name;
	        clip.addChild(button);
	        
	        var label:TextField = new TextField();
	        label.name = 'label';
	        label.selectable = false;
	        label.textColor = 0xffffff;
	        label.text = labelText;
	        label.width = label.textWidth + 4;
	        label.height = label.textHeight + 3;
	        button.addChild(label);
	        
	        button.graphics.moveTo(0, 0);
	        button.graphics.beginFill(0x821423, 1);
	        button.graphics.drawRect(0, 0, label.width, label.height);
	        button.graphics.endFill();

			button.addEventListener(MouseEvent.CLICK, action);
			button.useHandCursor = true;
			button.mouseChildren = false;
			button.buttonMode = true;
	        
	        return button;
	    }
	    
	    
	    
	    private function onEnterFrame(e:Event):void
	    {
	    	if (markers.currentYear == '0') yearLabel.text = '????';
	    	else if (markers.currentYear == 'undefined') yearLabel.text = '2007';
	    	else yearLabel.text = markers.currentYear;
	    	yearLabel.setTextFormat(textFormat);
	    
	    	storeCount.text = String(markers.markerIndex);
	    	storeCount.setTextFormat(textFormat);
	    }
	    
	    
		
	}
}
